% ifOldAppRunThenVerified
% sequence --> adapted
:- dec_p_type(ifOldAppRunThenVerifiedInstall).
ifOldAppRunThenVerifiedInstall :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    statesConsistency1(S) &
    notDupSysApp(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(InitVal,val) & dec(A1,idApp) & dec(M,manifest) & 
    dec(C,cert) & dec(SR,set(res)) &
    install(SystemPerm,InitVal,A1,M,C,SR,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedRevoke).
ifOldAppRunThenVerifiedRevoke :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(P1,perm) & dec(A1,idApp) &
    revoke(P1,A1,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedRevokeGroup).
ifOldAppRunThenVerifiedRevokeGroup :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(G,idGrp) & dec(A1,idApp) &
    revokeGroup(G,A1,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedRead).
ifOldAppRunThenVerifiedRead :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) & dec(CP,cProvider) & dec(U,uri) &
    read_op(SystemPerm,IC,CP,U,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedWrite).
ifOldAppRunThenVerifiedWrite :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) & dec(CP,cProvider) & dec(U,uri) & dec(NewV,val) &
    aWrite(SystemPerm,IC,CP,U,NewV,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedSendBroadcast).
ifOldAppRunThenVerifiedSendBroadcast :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) & dec(I,intent) & dec(P1,optp) &
    sendBroadcast(I,IC,P1,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedSendOrderedBroadcast).
ifOldAppRunThenVerifiedSendOrderedBroadcast :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) & dec(I,intent) & dec(P1,optp) &
    sendOrderedBroadcast(I,IC,P1,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedSendStickyBroadcast).
ifOldAppRunThenVerifiedSendStickyBroadcast :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) & dec(I,intent) &
    sendStickyBroadcast(I,IC,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedResolveIntent).
ifOldAppRunThenVerifiedResolveIntent :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(A1,idApp) & dec(I,intent) &
    resolveIntent1(SystemPerm,I,A1,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedReceiveIntent).
ifOldAppRunThenVerifiedReceiveIntent :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IntentActionType,rel(intent,pType)) & 
    dec(A1,idApp) & dec(I,intent) & dec(IC,iCmp) &
    receiveIntent1(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A1,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedStop).
ifOldAppRunThenVerifiedStop :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) &
    stop(IC,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedGrantP).
ifOldAppRunThenVerifiedGrantP :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) & dec(CP,cProvider) & dec(A1,idApp) & dec(U,uri) & 
    dec(PT,pType) &
    grantP(SystemPerm,IC,CP,A1,U,PT,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedRevokeDel).
ifOldAppRunThenVerifiedRevokeDel :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) & dec(CP,cProvider) & dec(U,uri) & dec(PT,pType) &
    revokeDel(SystemPerm,IC,CP,U,PT,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).

:- dec_p_type(ifOldAppRunThenVerifiedCall).
ifOldAppRunThenVerifiedCall :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    notDupApp(S) &
    notDupSysApp(S) &
    statesConsistency1(S) &

    dec(A,idApp) & dec(X0,sysImgApp) &
    (A in Apps or X0 in SS & idSI(X0,A)) &
    isOldApp(VulnerableSdk,A,S) &
    A nin AV &

    dec(IC,iCmp) & dec(SAC,sacall) &
    call_op(SystemPerm,IC,SAC,S,S_)

    implies neg(canRun(VulnerableSdk,A,S_))
  ).


% Different from all the other proofs in this file
% When verifyOldApp is run on A, then A can be run
:- dec_p_type(ifOldAppRunThenVerifiedVerifyOldApp).
ifOldAppRunThenVerifiedVerifyOldApp :-
  dec([S,S_],system) &
  dec(SystemPerm,set(perm)) & dec(VulnerableSdk,int) &

  dec(A,idApp) &

  neg(verifyOldApp(VulnerableSdk,A,S,S_) implies canRun(VulnerableSdk,A,S_)).

:- dec_p_type(check_ifOldAppRunThenVerified).
check_ifOldAppRunThenVerified :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking ifOldAppRunThenVerifiedInstall...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedInstall) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedRevoke...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedRevoke) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedRevokeGroup...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedRevokeGroup) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedRead...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedRead) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedWrite...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedWrite) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedSendBroadcast...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedSendBroadcast) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedSendOrderedBroadcast...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedSendOrderedBroadcast) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedSendStickyBroadcast...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedSendStickyBroadcast) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedResolveIntent...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedResolveIntent) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedReceiveIntent...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedReceiveIntent) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedStop...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedStop) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedGrantP...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedGrantP) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedRevokeDel...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedRevokeDel) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedCall...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedCall) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking ifOldAppRunThenVerifiedVerifyOldApp...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(ifOldAppRunThenVerifiedVerifyOldApp) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 15) discharged in ') &
     write(T) & write(' seconds') & nl
  ).


