% revokeAndNotGrant
% sequence --> adapted

:- dec_p_type(revokeAndNotGrantInstall).
revokeAndNotGrantInstall :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(InitVal,val) & dec(A1,idApp) & dec(M,manifest) & 
    dec(C,cert) & dec(SR,set(res)) &
    install(SystemPerm,InitVal,A1,M,C,SR,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantRevoke).
revokeAndNotGrantRevoke :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(P1,perm) & dec(A1,idApp) &
    revoke(P1,A1,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantRevokeGroup).
revokeAndNotGrantRevokeGroup :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(G,idGrp) & dec(A1,idApp) &
    revokeGroup(G,A1,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantRead).
revokeAndNotGrantRead :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) & dec(CP,cProvider) & dec(U,uri) &
    read_op(SystemPerm,IC,CP,U,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantWrite).
revokeAndNotGrantWrite :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) & dec(CP,cProvider) & dec(U,uri) & dec(NewV,val) &
    aWrite(SystemPerm,IC,CP,U,NewV,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantSendBroadcast).
revokeAndNotGrantSendBroadcast :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) & dec(I,intent) & dec(P1,optp) &
    sendBroadcast(I,IC,P1,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantSendOrderedBroadcast).
revokeAndNotGrantSendOrderedBroadcast :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) & dec(I,intent) & dec(P1,optp) &
    sendOrderedBroadcast(I,IC,P1,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantSendStickyBroadcast).
revokeAndNotGrantSendStickyBroadcast :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) & dec(I,intent) &
    sendStickyBroadcast(I,IC,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantResolveIntent).
revokeAndNotGrantResolveIntent :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(A1,idApp) & dec(I,intent) &
    resolveIntent1(SystemPerm,I,A1,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantReceiveIntent).
revokeAndNotGrantReceiveIntent :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(VulnerableSdk,int) & dec(IntentActionType,rel(intent,pType)) & 
    dec(A1,idApp) & dec(I,intent) & dec(IC,iCmp) &
    receiveIntent1(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A1,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantStop).
revokeAndNotGrantStop :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) &
    stop(IC,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantGrantp).
revokeAndNotGrantGrantp :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) & dec(CP,cProvider) & dec(A1,idApp) & dec(U,uri) & 
    dec(PT,pType) &
    grantP(SystemPerm,IC,CP,A1,U,PT,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantRevokeDel).
revokeAndNotGrantRevokeDel :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) & dec(CP,cProvider) & dec(U,uri) & dec(PT,pType) &
    revokeDel(SystemPerm,IC,CP,U,PT,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantCall).
revokeAndNotGrantCall :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(IC,iCmp) & dec(SAC,sacall) &
    call_op(SystemPerm,IC,SAC,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(revokeAndNotGrantVerifyOldApp).
revokeAndNotGrantVerifyOldApp :-
  dec([S,S1,S_],system) &
  dec(SystemPerm,set(perm)) & 
  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &
  dec(A,idApp) & dec(P,perm) &

  neg(
    pl(P,dangerous) &
    applyTo(DP,A,SP) & dec(SP,set(perm)) &
    P nin SP &
    revoke(P,A,S,S1) &

    dec(VulnerableSdk,int) & dec(A1,idApp) &
    verifyOldApp(VulnerableSdk,A1,S1,S_)

    implies neg(appHasPermission(SystemPerm,A,P,S_))
  ).

:- dec_p_type(check_revokeAndNotGrant).
check_revokeAndNotGrant :-
  dec([NPO,PO],int) &
  prolog_call((get_time(Ti),nb_setval(po,0))) &
  (nl & write('Checking revokeAndNotGrantInstall...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantInstall) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantRevoke...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantRevoke) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantRevokeGroup...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantRevokeGroup) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantRead...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantRead) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantWrite...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantWrite) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantSendBroadcast...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantSendBroadcast) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantSendOrderedBroadcast...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantSendOrderedBroadcast) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantSendStickyBroadcast...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantSendStickyBroadcast) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantResolveIntent...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantResolveIntent) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantReceiveIntent...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantReceiveIntent) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantStop...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantStop) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantGrantp...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantGrantp) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantRevokeDel...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantRevokeDel) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantCall...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantCall) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   nl & write('Checking revokeAndNotGrantVerifyOldApp...') & 
     prolog_call((nb_getval(po,PO),flush_output)) & NPO is PO+1 &
     naf(revokeAndNotGrantVerifyOldApp) &
     writedone & prolog_call((nb_setval(po,NPO),flush_output,fail)) or
   prolog_call((get_time(Te),nb_getval(po,PO),T is Te - Ti)) &
     nl & nl & write(PO) &
     write(' proof obligations (out of 15) discharged in ') &
     write(T) & write(' seconds') & nl
  ).

