:- dec_p_type(appCert(idApp,cert,system)).
appCert(A,C,S) :-
  environment(S,E) & dec(E,environment) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &
  
  (applyTo(CR,A,C)
   or
   SI in SSI & idSI(SI,A) & certSI(SI,C) & dec(SI,sysImgApp)
  ).

/*
:- dec_p_type(certOfDefiner(perm,cert,system)).
certOfDefiner(P,C,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &

  (applyTo(DP,A,{P / PP1}) & dec(A,idApp) & dec(PP1,set(perm)) &
   applyTo(CR,A,C)
   or
   SI in SSI & defPermsSI(SI,{P / PP2}) & certSI(SI,C) & 
     dec(PP2,set(perm)) & dec(SI,sysImgApp)   
  ).
*/

:- dec_p_type(certOfDefiner(perm,cert,system)).
certOfDefiner(P,C,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &

  (exists(A in Apps,[PP1],dec(A,idApp) &
     P in PP1 &
     applyTo(CR,A,C),
     applyTo(DP,A,PP1) & dec(PP1,set(perm))
   )
   or
   exists(SI in SSI,[PP2],dec(SI,sysImgApp) &
     P in PP2 &
     certSI(SI,C),
     defPermsSI(SI,PP2) & dec(PP2,set(perm))
   )
  ).

:- dec_p_type(n_certOfDefiner(perm,cert,system)).
n_certOfDefiner(P,C,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &

neg(
  (exists(A in Apps,[PP1],dec(A,idApp) &
     P in PP1 &
     applyTo(CR,A,C),
     applyTo(DP,A,PP1) & dec(PP1,set(perm))
   )
   or
   exists(SI in SSI,[PP2],dec(SI,sysImgApp) &
     P in PP2 &
     certSI(SI,C),
     defPermsSI(SI,PP2) & dec(PP2,set(perm))
   )
  )
).

:- dec_p_type(certOfDefiner21(perm,cert,system)).
certOfDefiner21(P,C,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &

  exists(A in Apps,[PP1],dec(A,idApp) &
     P in PP1 &
     applyTo(CR,A,C),
     applyTo(DP,A,PP1) & dec(PP1,set(perm))
   ).

:- dec_p_type(n_certOfDefiner21(perm,cert,system)).
n_certOfDefiner21(P,C,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &
  state(S,St) & dec(St,state) &
  apps(St,Apps) & dec(Apps,set(idApp)) &

  neg(
    exists(A in Apps,[PP1],dec(A,idApp) &
       P in PP1 &
       applyTo(CR,A,C),
       applyTo(DP,A,PP1) & dec(PP1,set(perm))
     )
  ).

:- dec_p_type(certOfDefiner22(perm,cert,system)).
certOfDefiner22(P,C,S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &

  exists(SI in SSI,[PP2],dec(SI,sysImgApp) &
    P in PP2 &
    certSI(SI,C),
    defPermsSI(SI,PP2) & dec(PP2,set(perm))
  ).

:- dec_p_type(n_certOfDefiner22(perm,cert,system)).
n_certOfDefiner22(P,C,S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &

  neg(
    exists(SI in SSI,[PP2],dec(SI,sysImgApp) &
      P in PP2 &
      certSI(SI,C),
      defPermsSI(SI,PP2) & dec(PP2,set(perm))
    )
  ).

:- dec_p_type(certOfDefiner2(perm,cert,system)).
certOfDefiner2(P,C,S) :-
  certOfDefiner21(P,C,S)
  or
  certOfDefiner22(P,C,S).

:- dec_p_type(n_certOfDefiner2(perm,cert,system)).
n_certOfDefiner2(P,C,S) :-
  neg(
    certOfDefiner21(P,C,S)
    or
    certOfDefiner22(P,C,S)
  ).

:- dec_p_type(isManifestOfApp(idApp,manifest,system)).
isManifestOfApp(A,M,S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &
  (applyTo(MM,A,M) 
   or
   exists(SI in SSI, idSI(SI,A) & manifestSI(SI,M) & dec(SI,sysImgApp))
  ).

:- dec_p_type(n_isManifestOfApp(idApp,manifest,system)).
n_isManifestOfApp(A,M,S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &

neg(
  (applyTo(MM,A,M) 
   or
   exists(SI in SSI, idSI(SI,A) & manifestSI(SI,M) & dec(SI,sysImgApp))
  )
).

/*
:- dec_p_type(appHasPermission(set(perm),idApp,perm,system)).
appHasPermission(SystemPerm,A,P,S) :-
  state(S,St) & dec(St,state) &
  perms(St,Perms) & dec(Perms,rel(idApp,set(perm))) &
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &

  dec([PP1,PP2,PP3],set(perm)) &

  applyTo(Perms,A,PP1) & 
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) &
  applyTo(DP,A,PP3) &
  appCert(A,C,S) & dec(C,cert) &

  (P in PP1
   or
   permExists(SystemPerm,P,S) &
   P in PP2 &
   (P in PP3
    or
    pl(P,normal)
    or
    certOfDefiner(P,C,S) &
    (pl(P,signature)
     or
     pl(P,signatureOrSys) &
     C = cert:manufacturerCert
    )
   )
  ).

:- dec_p_type(n_appHasPermission(set(perm),idApp,perm,system)).
n_appHasPermission(SystemPerm,A,P,S) :-
  state(S,St) & dec(St,state) &
  perms(St,Perms) & dec(Perms,rel(idApp,set(perm))) &
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &

  dec([PP1,PP2,PP3],set(perm)) &

  applyTo(Perms,A,PP1) & 
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) &
  applyTo(DP,A,PP3) &
  appCert(A,C,S) & dec(C,cert) &

neg(
  (P in PP1
   or
   permExists(SystemPerm,P,S) &
   P in PP2 &
   (P in PP3
    or
    pl(P,normal)
    or
    certOfDefiner(P,C,S) &
    (pl(P,signature)
     or
     pl(P,signatureOrSys) &
     C = cert:manufacturerCert
    )
   )
  )
).
*/
:- dec_p_type(appHasPermission1(set(perm),idApp,perm,system)).
appHasPermission1(SystemPerm,A,P,S) :-
  state(S,St) & dec(St,state) &
  perms(St,Perms) & dec(Perms,rel(idApp,set(perm))) &

  applyTo(Perms,A,PP1) & dec(PP1,set(perm)) &

  P in PP1.

:- dec_p_type(n_appHasPermission1(set(perm),idApp,perm,system)).
n_appHasPermission1(SystemPerm,A,P,S) :-
  state(S,St) & dec(St,state) &
  perms(St,Perms) & dec(Perms,rel(idApp,set(perm))) &

  applyTo(Perms,A,PP1) & dec(PP1,set(perm)) &

  neg(P in PP1).

:- dec_p_type(appHasPermission2(set(perm),idApp,perm,system)).
appHasPermission2(SystemPerm,A,P,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  state(S,St) & dec(St,state) &
  perms(St,Perms) & dec(Perms,rel(idApp,set(perm))) &

  dec([PP1,PP2,PP3],set(perm)) &

  applyTo(Perms,A,PP1) & 
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) &
  applyTo(DP,A,PP3) &
  appCert(A,C1,S) & dec(C1,cert) &

  permExists(SystemPerm,P,S) &
  P in PP2 &
  P in PP3.

:- dec_p_type(n_appHasPermission2(set(perm),idApp,perm,system)).
n_appHasPermission2(SystemPerm,A,P,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &

  dec([PP2,PP3],set(perm)) &

  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) &
  applyTo(DP,A,PP3) &

  neg(
    permExists(SystemPerm,P,S) &
    P in PP2 &
    P in PP3
  ).

:- dec_p_type(appHasPermission3(set(perm),idApp,perm,system)).
appHasPermission3(SystemPerm,A,P,S) :-
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) & dec(PP2,set(perm)) &

  permExists(SystemPerm,P,S) &
  P in PP2 &
  pl(P,normal).

:- dec_p_type(n_appHasPermission3(set(perm),idApp,perm,system)).
n_appHasPermission3(SystemPerm,A,P,S) :-
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) & dec(PP2,set(perm)) &

  neg(
    permExists(SystemPerm,P,S) &
    P in PP2 &
    pl(P,normal)
  ).

:- dec_p_type(appHasPermission4(set(perm),idApp,perm,system)).
appHasPermission4(SystemPerm,A,P,S) :-
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) & dec(PP2,set(perm)) &
  appCert(A,C,S) & dec(C,cert) &

  permExists(SystemPerm,P,S) &
  P in PP2 &
  certOfDefiner2(P,C,S) &
  pl(P,signature).

:- dec_p_type(n_appHasPermission4(set(perm),idApp,perm,system)).
n_appHasPermission4(SystemPerm,A,P,S) :-
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) & dec(PP2,set(perm)) &
  appCert(A,C,S) & dec(C,cert) &

  neg(
    permExists(SystemPerm,P,S) &
    P in PP2 &
    certOfDefiner2(P,C,S) &
    pl(P,signature)
  ).

:- dec_p_type(appHasPermission5(set(perm),idApp,perm,system)).
appHasPermission5(SystemPerm,A,P,S) :-
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) & dec(PP2,set(perm)) &
  appCert(A,C,S) & dec(C,cert) &

  permExists(SystemPerm,P,S) &
  P in PP2 &
  certOfDefiner2(P,C,S) &
  pl(P,signatureOrSys) &
  C = cert:manufacturerCert.

:- dec_p_type(n_appHasPermission5(set(perm),idApp,perm,system)).
n_appHasPermission5(SystemPerm,A,P,S) :-
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PP2) & dec(PP2,set(perm)) &
  appCert(A,C,S) & dec(C,cert) &

  neg(
    permExists(SystemPerm,P,S) &
    P in PP2 &
    certOfDefiner2(P,C,S) &
    pl(P,signatureOrSys) &
    C = cert:manufacturerCert
  ).

:- dec_p_type(appHasPermission(set(perm),idApp,perm,system)).
appHasPermission(SystemPerm,A,P,S) :-
  appHasPermission1(SystemPerm,A,P,S)
  or
  appHasPermission2(SystemPerm,A,P,S)
  or
  appHasPermission3(SystemPerm,A,P,S)
  or
  appHasPermission4(SystemPerm,A,P,S)
  or
  appHasPermission5(SystemPerm,A,P,S).

:- dec_p_type(n_appHasPermission(set(perm),idApp,perm,system)).
n_appHasPermission(SystemPerm,A,P,S) :-
  neg(
    appHasPermission1(SystemPerm,A,P,S)
    or
    appHasPermission2(SystemPerm,A,P,S)
    or
    appHasPermission3(SystemPerm,A,P,S)
    or
    appHasPermission4(SystemPerm,A,P,S)
    or
    appHasPermission5(SystemPerm,A,P,S)
  ).


