% install

:- dec_p_type(cmpDeclareIntentFilterCorrectly(cmp)).
cmpDeclareIntentFilterCorrectly(C) :-
  dec(FS,set(intentFilter)) &
  (dec(A,activity) &
   C = cmpAct(A) &
   intFilterA(A,FS)
   or
   dec(S,service) &
   C = cmpSrv(S) &
   intFilterA(S,FS)
   or
   dec(Br,broadReceiver) &
   C = cmpBR(Br) &
   intFilterA(Br,FS)
  ) &
  foreach(I1 in FS,[D1,C1],dec(I1,intentFilter) &
    (D1 neq {} or C1 neq {}),
      dec(D1,set(data)) & dec(C1,set(category)) & 
    dataFilter(I1,D1) & catFilter(I1,C1)
  )
  or
  dec(Cp,cProvider) &
  C = cmpCP(Cp).

:- dec_p_type(install(set(perm),val,idApp,manifest,cert,set(res),system,system)).
install(SystemPerm,InitVal,A,M,C,SR,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  apps(St,Apps) & apps(St_,Apps_) & dec([Apps,Apps_],set(idApp)) &
  resCont(St,RC) & resCont(St_,RC_) & dec([RC,RC_],rel([idApp,res],val)) &
  perms(St,Perms) & perms(St_,Perms_) & dec([Perms,Perms_],rel(idApp,set(perm))) &
  grantedPermGroups(St,MG) & grantedPermGroups(St_,MG_) &
    dec([MG,MG_],rel(idApp,set(idGrp))) &

  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &
  manifest(E,MM) & manifest(E_,MM_) & dec([MM,MM_],manifest_t) &
  cert(E,CR) & cert(E_,CR_) & dec([CR,CR_],rel(idApp,cert)) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &

% pre_install
  n_isAppInstalled(A,S) &

  cmp(M,SC) & dec(SC,set(cmp)) &
  foreach([X1 in SC,X2 in SC],[I1,I2],dec([X1,X2],cmp) &
    (I1 = I2 implies X1 = X2),
    dec([I1,I2],idCmp) & getCmpId(X1,I1) & getCmpId(X2,I2)
  ) &

  usrP(M,UP) & dec(UP,set(perm)) &
  foreach([U1 in UP,U2 in UP],[I3,I4],dec([U1,U2],perm) &
    (I3 = I4 implies U1 = U2),
    dec([I3,I4],idPerm) & idP(U1,I3) & idP(U2,I4)
  ) &

/*
  foreach(X3 in SC,[I0],dec(X3,cmp) & 
    foreach([A1,M1] in MM,[SC1],dec(A1,idApp) & dec(M1,manifest) &
      foreach(X6 in SC1,[I9],dec(X6,cmp) & 
        I0 neq I9,
        dec(I9,idCmp) & getCmpId(X6,I9)
      ),
      dec(SC1,set(cmp)) & cmp(M1,SC1)
    ),
    dec(I0,idCmp) & getCmpId(X3,I0)
  ) &
  foreach(X5 in SC,[Ia],dec(X5,cmp) & 
    foreach(S1 in SS,[SC2,N1],dec(S1,sysImgApp) &
      foreach(X7 in SC2,[Ib],dec(X7,cmp) & 
        Ia neq Ib,
        dec(Ib,idCmp) & getCmpId(X7,Ib)
      ),
      dec(SC2,set(cmp)) & dec(N1,manifest) & manifestSI(S1,N1) & cmp(N1,SC2)
    ),
    dec(Ia,idCmp) & getCmpId(X5,Ia)
  ) &
*/
  foreach(X3 in SC,[I0],dec(X3,cmp) & 
    foreach([A1,M1] in MM,[SC1],dec(A1,idApp) & dec(M1,manifest) &
      foreach(X6 in SC1,[I9],dec(X6,cmp) & 
        I0 neq I9,
        dec(I9,idCmp) & getCmpId(X6,I9)
      ),
      dec(SC1,set(cmp)) & cmp(M1,SC1)
    ) &
    foreach(S1 in SS,[SC2,N1],dec(S1,sysImgApp) &
      foreach(X7 in SC2,[Ib],dec(X7,cmp) & 
        I0 neq Ib,
        dec(Ib,idCmp) & getCmpId(X7,Ib)
      ),
      dec(SC2,set(cmp)) & dec(N1,manifest) & manifestSI(S1,N1) & cmp(N1,SC2)
    ),
    dec(I0,idCmp) & getCmpId(X3,I0)
  ) &

  foreach(U3 in UP,[I5],dec(U3,perm) &
    (foreach(U4 in SystemPerm,[I6],
       dec(U4,perm) & I5 neq I6,
       dec(I6,idPerm) & idP(U4,I6))
     implies
     foreach([A2,L2] in DP,dec(A2,idApp) & dec(L2,set(perm)) & 
       foreach(P2 in L2,[I7],
        dec(P2,perm) & I5 neq I7,
        dec(I7,idPerm) & idP(P2,I7)
       )
     ) &
     foreach(S2 in SS,[L3],dec(S2,sysImgApp) &
       foreach(P3 in L3,[I8],
         dec(P3,perm) & I5 neq I8,
         dec(I8,idPerm) & idP(P3,I8)
       ),
       dec(L3,set(perm)) & defPermsSI(S2,L3)
     )
    ),
    dec(I5,idPerm) & idP(U3,I5)
  ) &

  foreach(X4 in SC,dec(X4,cmp) & cmpDeclareIntentFilterCorrectly(X4)) &

% post_install
% foplus and extentional set are equivalent due to 
%   statesConsistency and first precondition
% foplus(MM,A,M,MM_) &
  MM_ = {[A,M] / MM} & [A,M] nin MM &

% foplus(CR,A,C,CR_) &
  CR_ = {[A,C] / CR} & [A,C] nin CR &

  Apps_ = {A / Apps} &

% this holds due to resContAppInst and as above
% oplus(RC,cp(cp({A},SR),{InitVal}),RC_) &
  un(RC,cp(cp({A},SR),{InitVal}),RC_) &

% foplus(DP,A,UP,DP_) &
  dec(UP1,set(perm)) &
  UP1 = ris(U5 in UP,[Ia],dec(U5,perm) &
          nexists(U6 in SystemPerm,[Ic],dec(U6,perm) &
            Ia = Ic,
            dec(Ic,idPerm) & idP(U6,Ic)
          ),
          U5,
          dec(Ia,idPerm) & idP(U5,Ia)
        ) &
  DP_ = {[A,UP1] / DP} & [A,UP1] nin DP &

% foplus(Perms,A,{},Perms_) &
  Perms_ = {[A,{}] / Perms} & [A,{}] nin Perms &

  use(M,PM) & dec(PM,set(perm)) &
  dec(SGrp,set(idGrp)) &
  foreach(P1 in PM,[PL,G],dec(P1,perm) & 
    (PL = normal implies G in SGrp),
    dec(PL,permLevel) & dec(G,idGrp) & pl(P1,PL) & maybeGrp(P1,grp(G))
  ) &
% foplus(MG,A,SGrp,MG_) &
  MG_ = {[A,SGrp] / MG} & [A,SGrp] nin MG &

  updateInstall(S,MM_,CR_,Apps_,RC_,DP_,Perms_,MG_,S_).


% uninstall

:- dec_p_type(uninstall(idApp,system,system)).
uninstall(A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  apps(St,Apps) & apps(St_,Apps_) & dec([Apps,Apps_],set(idApp)) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  alreadyVerified(St,AV) & alreadyVerified(St_,AV_) & dec([AV,AV_],set(idApp)) &
  perms(St,Perms) & perms(St_,Perms_) & 
    dec([Perms,Perms_],rel(idApp,set(perm))) &
  grantedPermGroups(St,MG) & grantedPermGroups(St_,MG_) &
    dec([MG,MG_],rel(idApp,set(idGrp))) &
  resCont(St,RC) & resCont(St_,RC_) & dec([RC,RC_],rel([idApp,res],val)) &
  delTPerms(St,DTP) & delTPerms(St_,DTP_) & 
    dec([DTP,DTP_],rel([iCmp,cProvider,uri],pType)) &
  delPPerms(St,DPP) & delPPerms(St_,DPP_) & 
    dec([DPP,DPP_],rel([idApp,cProvider,uri],pType)) &

  environment(S,E) & environment(S_,E_) & dec([E,E_],environment) &
  manifest(E,MM) & manifest(E_,MM_) & dec([MM,MM_],manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &
  cert(E,CR) & cert(E_,CR_) & dec([CR,CR_],rel(idApp,cert)) &
  defPerms(E,DP) & defPerms(E_,DP_) & dec([DP,DP_],rel(idApp,set(perm))) &

  A in Apps &

  foreach([I1,C1] in RR,dec(I1,iCmp) & dec(C1,cmp) &
    foreach([X1,M1] in MM,[SC1],dec(X1,idApp) & dec(M1,manifest) &
      (A neq X1 or C1 nin SC1),
      dec(SC1,set(cmp)) & cmp(M1,SC1)
    ) &
    foreach(S1 in SS,[B1,N1,SC2],dec(S1,sysImgApp) &
      (A neq B1 or C1 nin SC2),
        dec(B1,idApp) & dec(N1,manifest) & dec(SC2,set(cmp)) & 
      idSI(S1,B1) & manifestSI(S1,N1) & cmp(N1,SC2)
    )
  ) &

  MM = {[A,M2] / MM_} & [A,M2] nin MM_ & dec(M2,manifest) &

  CR = {[A,C2] / CR_} & [A,C2] nin CR_ & dec(C2,cert) &

  Apps = {A / Apps_} & A nin Apps_ &

  AV = {A / AV_} & A nin AV_ &

  applyTo(DP,A,DefPermsA) & dec(DefPermsA,set(perm)) &
  Perms_ = ris([X3,P1] in Perms,[P2],dec(X3,idApp) & dec(P1,set(perm)) &
               X3 neq A,
               [X3,P2],
               diff(P1,DefPermsA,P2) & dec(P2,set(perm))
           ) &

  MG = {[A,SI1] / MG_} & [A,SI1] nin MG_ & dec(SI1,set(idGrp)) &

  DP = {[A,P3] / DP_} & [A,P3] nin DP_ & dec(P3,set(perm)) &

  RC_ = ris([[X2,R1],V1] in RC,dec(X2,idApp) & dec(R1,res) & dec(V1,val) &
            X2 neq A
        ) &

  diff(DTP,DTP1,DTP_) & dec(DTP1,rel([iCmp,cProvider,uri],pType)) &
  DTP1 = ris([[IC1,CP1,U1],PT1] in DTP,
             (exists([X5,M3] in MM,[SC3],dec(X5,idApp) & dec(M3,manifest) &
                A = X5 & cmpCP(CP1) in SC3,
                cmp(M3,SC3) & dec(SC3,set(cmp))
              )
             or
              exists(S2 in SS,[X6,N2,SC4],dec(S2,sysImgApp) &
                A = X6 & cmpCP(CP1) in SC4,
                idSI(S2,X6) & manifestSI(S2,N2) & cmp(N2,SC4) &
                  dec(X6,idApp) & dec(N2,manifest) & dec(SC4,set(cmp))
              )
             ) &
             dec(IC1,iCmp) & dec(CP1,cProvider) & dec(U1,uri) & dec(PT1,pType)
         ) &

  DPP_ = ris([[IC2,CP2,U2],PT2] in DPP,
             A neq IC2 &
             foreach([X7,M4] in MM,[SC5],dec(X7,idApp) & dec(M4,manifest) &
               (A neq X7 or cmpCP(CP2) nin SC5),
               cmp(M4,SC5) & dec(SC5,set(cmp))
             ) &
             foreach(S3 in SS,[X8,N3,SC6],dec(S3,sysImgApp) &
               (A neq X8 or cmpCP(CP2) nin SC6),
               idSI(S3,X8) & manifestSI(S3,N3) & cmp(N3,SC6) &
                 dec(X8,idApp) & dec(N3,manifest) & dec(SC6,set(cmp))
             ) &
             dec(IC2,idApp) & dec(CP2,cProvider) & dec(U2,uri) & dec(PT2,pType)
         ) &

  running(St_,RR) &
  systemImage(E_,SS) &
  sentIntents(St,SI) & sentIntents(St_,SI) & dec(SI,set([iCmp,intent])).


% grant

% used only in PO delegateGrantPRevoke
:- dec_p_type(pre_grant(set(perm),idApp,perm,system)).
pre_grant(SystemPerm,A,P,S) :-
  state(S,St) & dec(St,state) &
  perms(St,Perms) & dec(Perms,rel(idApp,set(perm))) &
  grantedPermGroups(St,MG) & dec(MG,rel(idApp,set(idGrp))) &
  dec(G,idGrp) &
% pre_grant
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PM) & dec(PM,set(perm)) &
  P in PM &
  (P in SystemPerm or usrDefPerm(P,S)) &
  applyTo(Perms,A,PS) & dec(PS,set(perm)) &
  P nin PS &
  pl(P,dangerous) &
  (maybeGrp(P,nullg)
   or
   maybeGrp(P,grp(G)) &
   applyTo(MG,A,SG) & dec(SG,set(idGrp)) &
   G nin SG
  ).

:- dec_p_type(grant(set(perm),idApp,perm,system,system)).
grant(SystemPerm,A,P,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  perms(St,Perms) & perms(St_,Perms_) & dec([Perms,Perms_],rel(idApp,set(perm))) &
  grantedPermGroups(St,MG) & grantedPermGroups(St_,MG_) &
    dec([MG,MG_],rel(idApp,set(idGrp))) &
  dec(G,idGrp) &
% pre_grant
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PM) & dec(PM,set(perm)) &
  P in PM &
  (P in SystemPerm or usrDefPerm(P,S)) &
  applyTo(Perms,A,PS) & dec(PS,set(perm)) &
  P nin PS &
  pl(P,dangerous) &
  (maybeGrp(P,nullg) &
   MG_ = MG                 % part of post_grant
   or
   maybeGrp(P,grp(G)) &
   applyTo(MG,A,SG) & dec(SG,set(idGrp)) &
   G nin SG &
   foplus(MG,A,{G / SG},MG_)  % grantPermGroup and part of post_grant
  ) &
% grantPerm
  foplus(Perms,A,{P/PS},Perms_) &
% part of post_grant
  updateGrant(S,Perms_,MG_,S_).


% grantAuto

:- dec_p_type(grantAuto(set(perm),perm,idApp,system,system)).
grantAuto(SystemPerm,P,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  perms(St,Perms) & perms(St_,Perms_) & dec([Perms,Perms_],rel(idApp,set(perm))) &
  grantedPermGroups(St,MG) & dec(MG,rel(idApp,set(idGrp))) &
  dec(G,idGrp) &

% pre_grantAuto
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  use(M,PM) & dec(PM,set(perm)) &
  P in PM &
  (P in SystemPerm or usrDefPerm(P,S)) &
  applyTo(Perms,A,PS) & dec(PS,set(perm)) &
  P nin PS &
  pl(P,dangerous) &
  maybeGrp(P,grp(G)) &
  applyTo(MG,A,SG) & dec(SG,set(idGrp)) &
  G in SG &
% post_grantAuto
% grantPerm
  foplus(Perms,A,{P/PS},Perms_) &
  updateGrantAuto(S,Perms_,S_).

:- dec_p_type(pre_grantAuto(set(perm),perm,idApp,system)).
pre_grantAuto(SystemPerm,P,A,S) :-
% declarations
  dec(St,state) & dec(Perms,rel(idApp,set(perm))) &
  dec(MG,rel(idApp,set(idGrp))) &   dec(G,idGrp) &
  dec(PM,set(perm)) & dec(M,manifest) & dec(PS,set(perm)) &
  dec(SG,set(idGrp)) & dec(PL,permLevel) &
% let
  state(S,St) & 
  perms(St,Perms) & 
  grantedPermGroups(St,MG) & 
  use(M,PM) & 
  maybeGrp(P,grp(G)) &
  applyTo(Perms,A,PS) & 
  applyTo(MG,A,SG) & 
  pl(P,PL) &
% in
  isManifestOfApp(A,M,S) & 
  P in PM &
  (P in SystemPerm or usrDefPerm(P,S)) &
  P nin PS &
  PL = dangerous &
  G in SG.


:- dec_p_type(n_pre_grantAuto(set(perm),perm,idApp,system)).
n_pre_grantAuto(SystemPerm,P,A,S) :-
% declarations
  dec(St,state) & dec(Perms,rel(idApp,set(perm))) &
  dec(MG,rel(idApp,set(idGrp))) &   dec(G,idGrp) &
  dec(PM,set(perm)) & dec(M,manifest) & dec(PS,set(perm)) &
  dec(SG,set(idGrp)) & dec(PL,permLevel) &
% let
  state(S,St) & 
  perms(St,Perms) & 
  grantedPermGroups(St,MG) & 
  use(M,PM) & 
  maybeGrp(P,grp(G)) &
  applyTo(Perms,A,PS) & 
  applyTo(MG,A,SG) & 
  pl(P,PL) &
% in
  (PL in {normal,signature,signatureOrSys}   % pl(P,dangerous) can't be negated
   or
   neg(
     isManifestOfApp(A,M,S) & 
     P in PM &
     (P in SystemPerm or usrDefPerm(P,S)) &
     P nin PS &
     G in SG
   )
  ).


% revoke

:- dec_p_type(revoke(perm,idApp,system,system)).
revoke(P,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  perms(St,Perms) & perms(St_,Perms_) & dec([Perms,Perms_],rel(idApp,set(perm))) &

% pre_revoke
  applyTo(Perms,A,{P / PS}) & P nin PS & dec(PS,set(perm)) &
  maybeGrp(P,nullg) &
% post_revoke
  foplus(Perms,A,PS,Perms_) &
  updateRevoke(S,Perms_,S_).


% revokeGroup

:- dec_p_type(revokePermGroup(idGrp,idApp,system,system)).
revokePermGroup(G,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  grantedPermGroups(St,MG) & grantedPermGroups(St_,MG_) &
    dec([MG,MG_],rel(idApp,set(idGrp))) &

  applyTo(MG,A,{G / Grp}) & G nin Grp & dec(Grp,set(idGrp)) &
  foplus(MG,A,Grp,MG_).
  
:- dec_p_type(revokeGroup(idGrp,idApp,system,system)).
revokeGroup(G,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  grantedPermGroups(St,MG) & grantedPermGroups(St_,MG_) &
    dec([MG,MG_],rel(idApp,set(idGrp))) &
  perms(St,Perms) & perms(St_,Perms_) & 
    dec([Perms,Perms_],rel(idApp,set(perm))) &

% pre_revokeGroup
  applyTo(MG,A,{G / Grp}) & G nin Grp & dec(Grp,set(idGrp)) &
% post_revokeGroup
% revokePermGroup
  foplus(MG,A,Grp,MG_) &
% revokeGroupedPerms
  dec([PA,PA_],set(perm)) &
  applyTo(Perms,A,PA) &
  PA_ = ris(P in PA,[G1],
            G1 neq grp(G) & dec(P,perm),
            P,
            maybeGrp(P,G1) & dec(G1,optg)
        ) &
  foplus(Perms,A,PA_,Perms_) &
  updateRevokeGroup(S,Perms_,MG_,S_).

% hasPermission -- nothing to do

% read

:- dec_p_type(getCmpMinTargSdk(cmp,system,int,int)).
getCmpMinTargSdk(C,S,N,T) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &
  state(S,St) & dec(St,state) &
  apps(St,SA) & dec(SA,set(idApp)) &
  
  (exists(A in SA,[M,SC],dec(A,idApp) & 
     C in SC &
     minSdk(M,num(N)) &
     targetSdk(M,num(T)),
     applyTo(MM,A,M) & cmp(M,SC) & dec(SC,set(cmp)) & dec(M,manifest)
   )
   or
   exists(SI in SSI,[M1,SC1], dec(SI,sysImgApp) & 
     C in SC1 &
     minSdk(M1,num(N)) &
     targetSdk(M1,num(T)),
     manifestSI(SI,M1) & cmp(M1,SC1) & dec(SC1,set(cmp)) & dec(M1,manifest)
   )
  ).

:- dec_p_type(n_getCmpMinTargSdk(cmp,system,int,int)).
n_getCmpMinTargSdk(C,S,N,T) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SSI) & dec(SSI,set(sysImgApp)) &
  state(S,St) & dec(St,state) &
  apps(St,SA) & dec(SA,set(idApp)) &
  
neg(
  (exists(A in SA,[M,SC],dec(A,idApp) & 
     C in SC &
     minSdk(M,num(N)) &
     targetSdk(M,num(T)),
     applyTo(MM,A,M) & cmp(M,SC) & dec(SC,set(cmp)) & dec(M,manifest)
   )
   or
   exists(SI in SSI,[M1,SC1], dec(SI,sysImgApp) & 
     C in SC1 &
     minSdk(M1,num(N)) &
     targetSdk(M1,num(T)),
     manifestSI(SI,M1) & cmp(M1,SC1) & dec(SC1,set(cmp)) & dec(M1,manifest)
   )
  )
).

:- dec_p_type(getDefaultExp(cProvider,system)).
getDefaultExp(CP,S) :-
  getCmpMinTargSdk(cmpCP(CP),S,N,T) & dec([N,T],int) &

  (N =< 16 or T =< 16).

:- dec_p_type(n_getDefaultExp(cProvider,system)).
n_getDefaultExp(CP,S) :-
  getCmpMinTargSdk(cmpCP(CP),S,N,T) & dec([N,T],int) &

  neg(N =< 16 or T =< 16).

:- dec_p_type(canDoThis(set(perm),cmp,cProvider,system,optp)).
canDoThis(SystemPerm,C,CP,S,ThisE) :-
  dec([A1,A2],idApp) &
  inApp(C,A1,S) &
  isManifestOfApp(A2,M,S) & dec(M,manifest) &
  cmp(M,{cmpCP(CP) / SC1}) & dec(SC1,set(cmp)) &
  ((expC(CP,boolc(true)) or expC(CP,nullb) & getDefaultExp(CP,S)) &
   dec(P,perm) &
   (ThisE = permc(P)
    or
    ThisE = nullp & cmpEC(CP,permc(P))
    or
    ThisE = nullp & cmpEC(CP,nullp) & appE(M,permc(P))
   ) &
   appHasPermission(SystemPerm,A1,P,S)
   or
   A1 = A2
  ).

:- dec_p_type(delPerms(cmp,cProvider,uri,pType,system)).
delPerms(C,CP,U,PT,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  delTPerms(St,DTP) & dec(DTP,rel([iCmp,cProvider,uri],pType)) &
  delPPerms(St,DPP) & dec(DPP,rel([idApp,cProvider,uri],pType)) &

  dec(A,idApp) &
  inApp(C,A,S) &
  (applyTo(RR,IC1,C1) & dec(IC1,iCmp) & dec(C1,cmp) &
   inApp(C1,A,S) &
   (applyTo(DTP,[IC1,CP,U],both) or applyTo(DTP,[IC1,CP,U],PT))
   or
   applyTo(DPP,[A,CP,U],both)
   or
   applyTo(DPP,[A,CP,U],PT)
  ).

:- dec_p_type(canRead(set(perm),cmp,cProvider,system)).
canRead(SystemPerm,C,CP,S) :- 
  readE(CP,P) & canDoThis(SystemPerm,C,CP,S,P) & dec(P,optp).

% used only in PO delegateGrantPRevoke
:- dec_p_type(pre_read(set(perm),iCmp,cProvider,uri,system)).
pre_read(SystemPerm,IC,CP,U,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  existsRes(CP,U,S) &
  applyTo(RR,IC,C) & dec(C,cmp) &
  (canRead(SystemPerm,C,CP,S) or delPerms(C,CP,U,read,S)).

:- dec_p_type(read_op(set(perm),iCmp,cProvider,uri,system,system)).
read_op(SystemPerm,IC,CP,U,S,S_) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

delay(
  existsRes(CP,U,S) &
  applyTo(RR,IC,C) & dec(C,cmp) &
  (canRead(SystemPerm,C,CP,S) or delPerms(C,CP,U,read,S))
, false) &
  S = S_.



% write --> aWrite & bWrite

:- dec_p_type(canWrite(set(perm),cmp,cProvider,system)).
canWrite(SystemPerm,C,CP,S) :- 
  writeE(CP,P) & canDoThis(SystemPerm,C,CP,S,P) & dec(P,optp).

% aWrite is used to run all PO but allMapsCorrect9 and resContAppInst
:- dec_p_type(aWrite(set(perm),iCmp,cProvider,uri,val,system,system)).
aWrite(SystemPerm,IC,CP,U,NewV,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  resCont(St,RC) & resCont(St_,RC_) & dec([RC,RC_],rel([idApp,res],val)) &

delay(
% pre_write
  existsRes(CP,U,S) &
  applyTo(RR,IC,C) & dec(C,cmp) &
  neg(isCProvider(C)) &
  (canWrite(SystemPerm,C,CP,S) or delPerms(C,CP,U,write,S)) &
% post_write
  inApp(cmpCP(CP),A,S) & dec(A,idApp) &
  map_res(CP,Mr) & dec(Mr,rel(uri,res)) &
  applyTo(Mr,U,R) & dec(R,res) &
  foplus(RC,[A,R],NewV,RC_)
, false) &
  updateWrite(S,RC_,S_).

% bWrite is identical to aWrite except for delays
% it's used to run PO allMapsCorrect9 and resContAppInst
:- dec_p_type(bWrite(set(perm),iCmp,cProvider,uri,val,system,system)).
bWrite(SystemPerm,IC,CP,U,NewV,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  resCont(St,RC) & resCont(St_,RC_) & dec([RC,RC_],rel([idApp,res],val)) &

delay(
% pre_write
  existsRes(CP,U,S) &
  applyTo(RR,IC,C) & dec(C,cmp) &
  neg(isCProvider(C)) &
  (canWrite(SystemPerm,C,CP,S) or delPerms(C,CP,U,write,S))
, false) &
% post_write
  inApp(cmpCP(CP),A,S) & dec(A,idApp) &
delay(
  map_res(CP,Mr) & dec(Mr,rel(uri,res)) &
  applyTo(Mr,U,R) & dec(R,res)
, false) &
  foplus(RC,[A,R],NewV,RC_) &
  updateWrite(S,RC_,S_).


% sendIntent

:- dec_p_type(createIntent(intent,optp,intent)).
createIntent(I,P,I_) :-
  idI(I,_1) &
  cmpName(I,_2) &
  intType(I,_3) &
  action(I,_4) &
  data(I,_5) &
  category(I,_6) &
  extra(I,_7) &
  flags(I,_8) &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_8,optf) &
  I_ = [_1,_2,_3,_4,_5,_6,_7,_8,P].

:- dec_p_type(startActivity(intent,iCmp,system,system)).
startActivity(I,IC,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &

% pre_startActivity
  intType(I,intActivity) &
  brperm(I,nullp) &
% cmpRunAppIns makes inApp c a s unnecessary
  applyTo(RR,IC,C) & neg(isCProvider(C)) & dec(C,cmp) &
  idI(I,ID) & dec(ID,idInt) &
  nexists([IC1,I1] in SI,[ID1],dec(IC1,iCmp) & dec(I1,intent) &
    ID1 = ID,
    idI(I1,ID1) & dec(ID1,idInt)
  ) &
% post_startActivity
  createIntent(I,nullp,I_) & dec(I_,intent) &
  SI_ = {[IC,I_] / SI} &
  updateIntents(S,SI_,S_).

:- dec_p_type(startActivityForResult(intent,iCmp,system,system)).
startActivityForResult(I,IC,S,S_) :- startActivity(I,IC,S,S_).

:- dec_p_type(startService(intent,iCmp,system,system)).
startService(I,IC,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &

% pre_startService
  intType(I,intService) &
  brperm(I,nullp) &
% cmpRunAppIns makes inApp c a s unnecessary
  applyTo(RR,IC,C) & neg(isCProvider(C)) & dec(C,cmp) &
  idI(I,ID) & dec(ID,idInt) &
  nexists([IC1,I1] in SI,[ID1],dec(IC1,iCmp) & dec(I1,intent) &
    ID1 = ID,
    idI(I1,ID1) & dec(ID1,idInt)
  ) &
% post_startService (same as startActivity)
  createIntent(I,nullp,I_) & dec(I_,intent) &
  SI_ = {[IC,I_] / SI} &
  updateIntents(S,SI_,S_).

:- dec_p_type(sendBroadcast(intent,iCmp,optp,system,system)).
sendBroadcast(I,IC,P,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &

% pre_sendBroadcast
  intType(I,intBroadcast) &
  brperm(I,nullp) &
% cmpRunAppIns makes inApp c a s unnecessary
  applyTo(RR,IC,C) & neg(isCProvider(C)) & dec(C,cmp) &
  idI(I,ID) & dec(ID,idInt) &
  nexists([IC1,I1] in SI,[ID1],dec(IC1,iCmp) & dec(I1,intent) &
    ID1 = ID,
    idI(I1,ID1) & dec(ID1,idInt)
  ) &
% post_sendBroadcast (same as startActivity)
  createIntent(I,P,I_) & dec(I_,intent) &
  SI_ = {[IC,I_] / SI} &
  updateIntents(S,SI_,S_).

:- dec_p_type(sendOrderedBroadcast(intent,iCmp,optp,system,system)).
sendOrderedBroadcast(I,IC,P,S,S_) :- sendBroadcast(I,IC,P,S,S_).

:- dec_p_type(sendStickyBroadcast(intent,iCmp,system,system)).
sendStickyBroadcast(I,IC,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &

% pre_sendStickyBroadcast (same as sendBroadcast)
  intType(I,intBroadcast) &
  brperm(I,nullp) &
% cmpRunAppIns makes inApp c a s unnecessary
  applyTo(RR,IC,C) & neg(isCProvider(C)) & dec(C,cmp) &
  idI(I,ID) & dec(ID,idInt) &
  nexists([IC1,I1] in SI,[ID1],dec(IC1,iCmp) & dec(I1,intent) &
    ID1 = ID,
    idI(I1,ID1) & dec(ID1,idInt)
  ) &
% post_sendStickyBroadcast (same as startActivity)
  createIntent(I,nullp,I_) & dec(I_,intent) &
  SI_ = {[IC,I_] / SI} &
  updateIntents(S,SI_,S_).


% resolveIntent

:- dec_p_type(actionTest(intent,intentFilter)).
actionTest(I,IF) :-
  action(I,OA) & dec(OA,opta) &
  actFilter(IF,IA) & dec(IA,set(intentAction)) &
  (OA = nulla &
   IA neq {}
   or
   OA = act(A) & dec(A,intentAction) &
   A in IA
  ).

:- dec_p_type(categoryTest(intent,intentFilter)).
categoryTest(I,IF) :-
  category(I,SC1) & dec(SC1,set(category)) &
  (SC1 = {}
   or
   catFilter(IF,SC2) & dec(SC2,set(category)) &
   subset(SC1,SC2)
  ).

:- dec_p_type(isContentOrFile(intent)).
isContentOrFile(I) :-
  data(I,D) & dec(D,data) &
  (type(D,content)
   or
   type(D,file)
  ).

:- dec_p_type(notUriAndNotMime(intent,intentFilter)).
notUriAndNotMime(I,IF) :-
  data(I,D) & dec(D,data) &
  path(D,nullu) &
  mime(D,nullm) &
  dataFilter(IF,{}).

:- dec_p_type(uriAndNotMime(intent,intentFilter)).
uriAndNotMime(I,IF) :-
  data(I,D) & dec(D,data) &
  path(D,uric(U)) & dec(U,uri) &
  mime(D,nullm) &
  dataFilter(IF,{D / SD}) & dec(SD,set(data)).

:- dec_p_type(notUriAndMime(intent,intentFilter)).
notUriAndMime(I,IF) :-
  data(I,D) & dec(D,data) &
  path(D,nullu) & 
  mime(D,mt(MT)) & dec(MT,mimeType) &
  dataFilter(IF,{D / SD}) & dec(SD,set(data)).

:- dec_p_type(uriAndMime(intent,intentFilter)).
uriAndMime(I,IF) :-
  data(I,D) & dec(D,data) &
  path(D,uric(U)) & dec(U,uri) &
  mime(D,mt(MT)) & dec(MT,mimeType) &
  dataFilter(IF,SD) & dec(SD,set(data)) &
  dec([DCmp1,DCmp2],data) &
  mime(DCmp1,mt(MT)) &
  DCmp1 in SD &
  (path(DCmp2,uric(U))
   or
   isContentOrFile(I) & path(DCmp2,nullu)
  ) &
  DCmp2 in SD.

:- dec_p_type(dataTest(intent,intentFilter)).
dataTest(I,IF) :-
  notUriAndNotMime(I,IF)
  or
  uriAndNotMime(I,IF)
  or
  notUriAndMime(I,IF)
  or
  uriAndMime(I,IF).

:- dec_p_type(canBeStarted(cmp,system)).
canBeStarted(C,S) :-
  C = cmpAct(A) & dec(A,activity) &
  (expA(A,boolc(true)) or expA(A,nullb) & intFilterA(A,{}))
  or
  C = cmpSrv(Sr) & dec(Sr,service) &
  (expS(Sr,boolc(true)) or expS(Sr,nullb) & intFilterS(Sr,{}))
  or
  C = cmpCP(Cp) & dec(Cp,cProvider) &
  (expC(Cp,boolc(true)) or expC(Cp,nullb) & getDefaultExp(Cp,S))
  or
  C = cmpBR(Br) & dec(Br,broadReceiver) &
  (expB(Br,boolc(true)) or expB(Br,nullb) & intFilterB(Br,{})).

:- dec_p_type(n_canBeStarted(cmp,system)).
n_canBeStarted(C,S) :-
  C = cmpAct(A) & dec(A,activity) &
  neg(expA(A,boolc(true)) or expA(A,nullb) & intFilterA(A,{}))
  or
  C = cmpSrv(Sr) & dec(Sr,service) &
  neg(expS(Sr,boolc(true)) or expS(Sr,nullb) & intFilterS(Sr,{}))
  or
  C = cmpCP(Cp) & dec(Cp,cProvider) &
  neg(expC(Cp,boolc(true)) or expC(Cp,nullb) & getDefaultExp(Cp,S))
  or
  C = cmpBR(Br) & dec(Br,broadReceiver) &
  neg(expB(Br,boolc(true)) or expB(Br,nullb) & intFilterB(Br,{})).
/*
:- dec_p_type(canStart(set(perm),cmp,cmp,system)).
canStart(SystemPerm,C1,C2,S) :-
  inApp(C1,A1,S) & dec(A1,idApp) &
  inApp(C2,A2,S) & dec(A2,idApp) &
  (A1 = A2
   or
   canBeStarted(C2,S) &
delay(
   isManifestOfApp(A1,M,S) & dec(M,manifest) &
   dec(P,perm) &
   (C2 = cmpAct(A) & dec(A,activity) &
    (cmpEA(A,permc(P)) or cmpEA(A,nullp) & appE(M,permc(P)))
    or
    C2 = cmpSrv(Sr) & dec(Sr,service) &
    (cmpES(Sr,permc(P)) or cmpES(Sr,nullp) & appE(M,permc(P)))
    or
    C2 = cmpCP(Cp) & dec(Cp,cProvider) &
    (cmpEC(Cp,permc(P)) or cmpEC(Cp,nullp) & appE(M,permc(P)))
    or
    C2 = cmpBR(Br) & dec(Br,broadReceiver) &
    (cmpEB(Br,permc(P)) or cmpEB(Br,nullp) & appE(M,permc(P)))
   ) &
   appHasPermission(SystemPerm,A1,P,S)
, false)
  ).
*/

:- dec_p_type(canStart1(set(perm),cmp,cmp,system)).
canStart1(SystemPerm,C1,C2,S) :-
  inApp(C1,A1,S) & dec(A1,idApp) &
  inApp(C2,A2,S) & dec(A2,idApp) &
  A1 = A2.

:- dec_p_type(n_canStart1(set(perm),cmp,cmp,system)).
n_canStart1(SystemPerm,C1,C2,S) :-
  inApp(C1,A1,S) & dec(A1,idApp) &
  inApp(C2,A2,S) & dec(A2,idApp) &

  neg(A1 = A2).

:- dec_p_type(canStart2(set(perm),cmp,cmp,system)).
canStart2(SystemPerm,C1,C2,S) :-
  delay(
    inApp(C1,A1,S) & dec(A1,idApp) &
    inApp(C2,A2,S) & dec(A2,idApp),
    false
  ) &
  canBeStarted(C2,S) &
  delay(
    isManifestOfApp(A1,M,S) & dec(M,manifest) &
    dec(P,perm) &
    (C2 = cmpAct(A) & dec(A,activity) &
     (cmpEA(A,permc(P)) or cmpEA(A,nullp) & appE(M,permc(P)))
     or
     C2 = cmpSrv(Sr) & dec(Sr,service) &
     (cmpES(Sr,permc(P)) or cmpES(Sr,nullp) & appE(M,permc(P)))
     or
     C2 = cmpCP(Cp) & dec(Cp,cProvider) &
     (cmpEC(Cp,permc(P)) or cmpEC(Cp,nullp) & appE(M,permc(P)))
     or
     C2 = cmpBR(Br) & dec(Br,broadReceiver) &
     (cmpEB(Br,permc(P)) or cmpEB(Br,nullp) & appE(M,permc(P)))
    ) &
    appHasPermission(SystemPerm,A1,P,S),
    false
  ).

:- dec_p_type(n_canStart2(set(perm),cmp,cmp,system)).
n_canStart2(SystemPerm,C1,C2,S) :-
  inApp(C1,A1,S) & dec(A1,idApp) &
  inApp(C2,A2,S) & dec(A2,idApp) &
  isManifestOfApp(A1,M,S) & dec(M,manifest) &
  dec(P,perm) &
  (C2 = cmpAct(A) & dec(A,activity) &
   (cmpEA(A,permc(P)) or cmpEA(A,nullp) & appE(M,permc(P)))
   or
   C2 = cmpSrv(Sr) & dec(Sr,service) &
   (cmpES(Sr,permc(P)) or cmpES(Sr,nullp) & appE(M,permc(P)))
   or
   C2 = cmpCP(Cp) & dec(Cp,cProvider) &
   (cmpEC(Cp,permc(P)) or cmpEC(Cp,nullp) & appE(M,permc(P)))
   or
   C2 = cmpBR(Br) & dec(Br,broadReceiver) &
   (cmpEB(Br,permc(P)) or cmpEB(Br,nullp) & appE(M,permc(P)))
  ) &

  neg(
    canBeStarted(C2,S) &
    appHasPermission(SystemPerm,A1,P,S)
  ).

:- dec_p_type(canStart(set(perm),cmp,cmp,system)).
canStart(SystemPerm,C1,C2,S) :-
  canStart1(SystemPerm,C1,C2,S)
  or
  canStart2(SystemPerm,C1,C2,S).

:- dec_p_type(n_canStart(set(perm),cmp,cmp,system)).
n_canStart(SystemPerm,C1,C2,S) :-
  neg(
    canStart1(SystemPerm,C1,C2,S)
    or
    canStart2(SystemPerm,C1,C2,S)
  ).

:- dec_p_type(updateIntent(intent,opti,intent)).
updateIntent(I,Id,I_) :-
  idI(I,_1) &
  intType(I,_3) &
  action(I,_4) &
  data(I,_5) &
  category(I,_6) &
  extra(I,_7) &
  flags(I,_8) &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_8,optf) &
    dec(_9,optp) &
  I_ = [_1,Id,_3,_4,_5,_6,_7,_8,_9].

% resolveIntent1 is used to run all PO but resolveIntentPInoDupSentIntents
:- dec_p_type(resolveIntent1(set(perm),intent,idApp,system,system)).
resolveIntent1(SystemPerm,I,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &

delay(
% pre_resolveIntent
  cmpName(I,nulli) &
  SI = {[IC,I] / SI1} & [IC,I] nin SI1 & 
    dec(IC,iCmp) & dec(SI1,set([iCmp,intent])) &
  applyTo(RR,IC,C1) & dec(C1,cmp) &
  inApp(C2,A,S) & dec(C2,cmp) &
  intType(I,IT) & dec(IT,intentType) &
  dec(IFil,intentFilter) & dec(SIF,set(intentFilter)) &
  (IT = intActivity & cmpAct(Act) = C2 & intFilterA(Act,{IFil / SIF}) & 
     dec(Act,activity)
   or
   IT = intService & cmpSrv(Sr) = C2 & intFilterS(Sr,{IFil / SIF}) &
     dec(Sr,service)
   or
   IT = intBroadcast & cmpBR(Br) = C2 & intFilterB(Br,{IFil / SIF}) &
     dec(Br,broadReceiver)
  ) &
  actionTest(I,IFil) &
  categoryTest(I,IFil) &
  dataTest(I,IFil) &
  canStart(SystemPerm,C1,C2,S) &
% post_resolveIntent
  getCmpId(C2,Id) & dec(Id,idCmp) &
  updateIntent(I,idcmp(Id),I_) & dec(I_,intent) &
  SI_ = {[IC,I_] / SI1}
, false) &
  updateIntents(S,SI_,S_).

% resolveIntent2 is identical to resolveIntent1 except for delays
% it's used to run PO resolveIntentPInoDupSentIntents
:- dec_p_type(resolveIntent2(set(perm),intent,idApp,system,system)).
resolveIntent2(SystemPerm,I,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &

% pre_resolveIntent
  cmpName(I,nulli) &
  SI = {[IC,I] / SI1} & [IC,I] nin SI1 & 
    dec(IC,iCmp) & dec(SI1,set([iCmp,intent])) &
delay(
  applyTo(RR,IC,C1) & dec(C1,cmp) &
  inApp(C2,A,S) & dec(C2,cmp) &
  intType(I,IT) & dec(IT,intentType) &
  dec(IFil,intentFilter) & dec(SIF,set(intentFilter)) &
  (IT = intActivity & cmpAct(Act) = C2 & intFilterA(Act,{IFil / SIF}) & 
     dec(Act,activity)
   or
   IT = intService & cmpSrv(Sr) = C2 & intFilterS(Sr,{IFil / SIF}) &
     dec(Sr,service)
   or
   IT = intBroadcast & cmpBR(Br) = C2 & intFilterB(Br,{IFil / SIF}) &
     dec(Br,broadReceiver)
  ) &
  actionTest(I,IFil) &
  categoryTest(I,IFil) &
  dataTest(I,IFil) &
  canStart(SystemPerm,C1,C2,S)
, false) &
% post_resolveIntent
  getCmpId(C2,Id) & dec(Id,idCmp) &
  updateIntent(I,idcmp(Id),I_) & dec(I_,intent) &
  SI_ = {[IC,I_] / SI1} &
  updateIntents(S,SI_,S_).


% receiveIntent

:- dec_p_type(intentForApp(intent,idApp,cmp,iCmp,system)).
intentForApp(I,A,C,IC,S) :-
  state(S,St) & dec(St,state) &
  sentIntents(St,SI) & dec(SI,set([iCmp,intent])) &

  getCmpId(C,Id) & dec(Id,idCmp) &
  cmpName(I,idcmp(Id)) &
  [IC,I] in SI &
  inApp(C,A,S).

:- dec_p_type(canGrant(cProvider,uri,system)).
canGrant(CP,U,S) :-
  inApp(cmpCP(CP),A,S) & dec(A,idApp) &
  uriP(CP,SU) & dec(SU,set(uri)) &
  (U in SU
   or
   SU = {} & grantU(CP,true)
  ).

:- dec_p_type(canRun(int,idApp,system)).
canRun(VulnerableSdk,A,S) :-
  state(S,St) & dec(St,state) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &

  (A in AV
   or
   isManifestOfApp(A,M,S) & targetSdk(M,num(N)) & VulnerableSdk < N &
     dec(M,manifest) & dec(N,int)
  ).

:- dec_p_type(n_canRun(int,idApp,system)).
n_canRun(VulnerableSdk,A,S) :-
  state(S,St) & dec(St,state) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &

  A nin AV &
  isManifestOfApp(A,M,S) & dec(M,manifest) & 
  (targetSdk(M,nulln) 
   or 
   targetSdk(M,num(N)) & N =< VulnerableSdk  & dec(N,int)
  ).

% pre_receiveIntent not used in receiveIntent definition
% used only in proofs
:- dec_p_type(
     pre_receiveIntent1(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system)).
pre_receiveIntent1(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  delay(
    canRun(VulnerableSdk,A,S) &
    intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
    neg(isCProvider(C1)) &
    applyTo(RR,IC,C2) & dec(C2,cmp) &
    neg(isCProvider(C2)) &
    canStart(SystemPerm,C2,C1,S),
    false) &

  (intType(I,intActivity) &
   delay(
     data(I,D) & dec(D,data) &
     path(D,uric(U)) & dec(U,uri) &
     existsRes(CP,U,S) & dec(CP,cProvider) &
     canGrant(CP,U,S) &
     applyTo(IntentActionType,I,AT) & dec(AT,pType) &
     (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
      or
      AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
      or
      AT = both & 
      (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
      (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
     ),
     false)
   or
   intType(I,intBroadcast) &
   brperm(I,permc(P)) & dec(P,perm) &
   appHasPermission1(SystemPerm,A,P,S)
  ).

:- dec_p_type(
     pre_receiveIntent21(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system)).
pre_receiveIntent21(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  delay(
    canRun(VulnerableSdk,A,S) &
    intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
    neg(isCProvider(C1)) &
    applyTo(RR,IC,C2) & dec(C2,cmp) &
    neg(isCProvider(C2)) &
    canStart(SystemPerm,C2,C1,S),
    false) &
  intType(I,intActivity) &
  delay(
    data(I,D) & dec(D,data) &
    path(D,uric(U)) & dec(U,uri) &
    existsRes(CP,U,S) & dec(CP,cProvider) &
    canGrant(CP,U,S) &
    applyTo(IntentActionType,I,AT) & dec(AT,pType) &
    (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
     or
     AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
     or
     AT = both & 
     (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
     (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
    ),
    false).

:- dec_p_type(
     pre_receiveIntent22(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system)).
pre_receiveIntent22(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  delay(
    canRun(VulnerableSdk,A,S) &
    intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
    neg(isCProvider(C1)) &
    applyTo(RR,IC,C2) & dec(C2,cmp) &
    neg(isCProvider(C2)) &
    canStart(SystemPerm,C2,C1,S),
    false) &
  intType(I,intBroadcast) &
  brperm(I,permc(P)) & dec(P,perm) &
  appHasPermission2(SystemPerm,A,P,S).

:- dec_p_type(
     pre_receiveIntent3(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system)).
pre_receiveIntent3(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  delay(
    canRun(VulnerableSdk,A,S) &
    intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
    neg(isCProvider(C1)) &
    applyTo(RR,IC,C2) & dec(C2,cmp) &
    neg(isCProvider(C2)) &
    canStart(SystemPerm,C2,C1,S),
    false) &

  (intType(I,intActivity) &
   delay(
     data(I,D) & dec(D,data) &
     path(D,uric(U)) & dec(U,uri) &
     existsRes(CP,U,S) & dec(CP,cProvider) &
     canGrant(CP,U,S) &
     applyTo(IntentActionType,I,AT) & dec(AT,pType) &
     (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
      or
      AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
      or
      AT = both & 
      (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
      (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
     ),
     false)
   or
   intType(I,intBroadcast) &
   brperm(I,permc(P)) & dec(P,perm) &
   appHasPermission3(SystemPerm,A,P,S)
  ).

:- dec_p_type(
     pre_receiveIntent4(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system)).
pre_receiveIntent4(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  delay(
    canRun(VulnerableSdk,A,S) &
    intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
    neg(isCProvider(C1)) &
    applyTo(RR,IC,C2) & dec(C2,cmp) &
    neg(isCProvider(C2)) &
    canStart(SystemPerm,C2,C1,S),
    false) &

  (intType(I,intActivity) &
   delay(
     data(I,D) & dec(D,data) &
     path(D,uric(U)) & dec(U,uri) &
     existsRes(CP,U,S) & dec(CP,cProvider) &
     canGrant(CP,U,S) &
     applyTo(IntentActionType,I,AT) & dec(AT,pType) &
     (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
      or
      AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
      or
      AT = both & 
      (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
      (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
     ),
     false)
   or
   intType(I,intBroadcast) &
   brperm(I,permc(P)) & dec(P,perm) &
   appHasPermission4(SystemPerm,A,P,S)
  ).

:- dec_p_type(
     pre_receiveIntent5(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system)).
pre_receiveIntent5(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  delay(
    canRun(VulnerableSdk,A,S) &
    intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
    neg(isCProvider(C1)) &
    applyTo(RR,IC,C2) & dec(C2,cmp) &
    neg(isCProvider(C2)) &
    canStart(SystemPerm,C2,C1,S),
    false) &

  (intType(I,intActivity) &
   delay(
     data(I,D) & dec(D,data) &
     path(D,uric(U)) & dec(U,uri) &
     existsRes(CP,U,S) & dec(CP,cProvider) &
     canGrant(CP,U,S) &
     applyTo(IntentActionType,I,AT) & dec(AT,pType) &
     (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
      or
      AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
      or
      AT = both & 
      (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
      (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
     ),
     false)
   or
   intType(I,intBroadcast) &
   brperm(I,permc(P)) & dec(P,perm) &
   appHasPermission5(SystemPerm,A,P,S)
  ).

% used to run PO intentSpoofing1
:- dec_p_type(
     pre_receiveIntent6(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system)).
pre_receiveIntent6(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
  applyTo(RR,IC,C2) & dec(C2,cmp) &
  canStart1(SystemPerm,C2,C1,S) &

  delay(
    canRun(VulnerableSdk,A,S) &
    neg(isCProvider(C1)) &
    neg(isCProvider(C2)) &
    (intType(I,intActivity) &
       data(I,D) & dec(D,data) &
       path(D,uric(U)) & dec(U,uri) &
       existsRes(CP,U,S) & dec(CP,cProvider) &
       canGrant(CP,U,S) &
       applyTo(IntentActionType,I,AT) & dec(AT,pType) &
       (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
        or
        AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
        or
        AT = both & 
        (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
        (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
       )
     or
     intType(I,intBroadcast) &
     brperm(I,permc(P)) & dec(P,perm) &
     appHasPermission(SystemPerm,A,P,S)
    ),
    false
  ).

% used to run PO intentSpoofing2
:- dec_p_type(
     pre_receiveIntent7(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system)).
pre_receiveIntent7(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
  canStart2(SystemPerm,C2,C1,S) & dec(C2,cmp) &

  delay(
    canRun(VulnerableSdk,A,S) &
    applyTo(RR,IC,C2) & 
    neg(isCProvider(C1)) &
    neg(isCProvider(C2)) &
    (intType(I,intActivity) &
       data(I,D) & dec(D,data) &
       path(D,uric(U)) & dec(U,uri) &
       existsRes(CP,U,S) & dec(CP,cProvider) &
       canGrant(CP,U,S) &
       applyTo(IntentActionType,I,AT) & dec(AT,pType) &
       (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
        or
        AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
        or
        AT = both & 
        (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
        (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
       )
     or
     intType(I,intBroadcast) &
     brperm(I,permc(P)) & dec(P,perm) &
     appHasPermission(SystemPerm,A,P,S)
    ),
    false
  ).




% receiveIntent1 is used to run all PO but receiveIntentPIdelTmpRun,
%   receiveIntentPInotCPrunning, receiveIntentPIcmpRunAppIns,
%   receiveIntentPIallMapsCorrect6, receiveIntentPIallMapsCorrect8 and
%   receiveIntentPInoDupSentIntents
:- dec_p_type(
     receiveIntent1(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system,system)).
receiveIntent1(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & running(St_,RR_) & dec([RR,RR_],rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &
  delTPerms(St,DTP) & delTPerms(St_,DTP_) & 
    dec([DTP,DTP_],rel([iCmp,cProvider,uri],pType)) &

delay(
% pre_receiveIntent
  canRun(VulnerableSdk,A,S) &
  intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
  neg(isCProvider(C1)) &
  applyTo(RR,IC,C2) & dec(C2,cmp) &
  neg(isCProvider(C2)) &
  canStart(SystemPerm,C2,C1,S) &

  dec(IC1,iCmp) &
  comp({[IC1,IC1]},RR,{}) & 

  (intType(I,intActivity) &
   data(I,D) & dec(D,data) &
   (path(D,uric(U)) & dec(U,uri) &
    existsRes(CP,U,S) & dec(CP,cProvider) &
    canGrant(CP,U,S) &
    applyTo(IntentActionType,I,AT) & dec(AT,pType) &
    (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
     or
     AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
     or
     AT = both & 
     (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
     (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
    ) &
    foplus(DTP,[IC1,CP,U],AT,DTP_)
    or
    path(D,nullu) &
    DTP_ = DTP
   )
   or
   intType(I,intService) &
   DTP_ = DTP
   or
   intType(I,intBroadcast) &
   brperm(I,permc(P)) & dec(P,perm) &
   appHasPermission(SystemPerm,A,P,S) &
   DTP_ = DTP
  ) &
% part of post_receiveIntent
  RR_ = {[IC1,C1] / RR} &
  SI = {[IC,I] / SI_} & [IC,I] nin SI_
, false) &
  updateReceiveIntent(S,RR_,DTP_,SI_,S_).

% receiveIntent2 is identical to receiveIntent1 except for delays
% it's used to run PO
%   receiveIntentPInotCPrunning, receiveIntentPIcmpRunAppIns,
%   receiveIntentPIallMapsCorrect6, receiveIntentPIallMapsCorrect8,
%   receiveIntentPInoDupSentIntents and receiveIntentPIdelTmpRun
:- dec_p_type(
     receiveIntent2(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system,system)).
receiveIntent2(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & running(St_,RR_) & dec([RR,RR_],rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &
  delTPerms(St,DTP) & delTPerms(St_,DTP_) & 
    dec([DTP,DTP_],rel([iCmp,cProvider,uri],pType)) &

delay(
% pre_receiveIntent
  canRun(VulnerableSdk,A,S)
, false) &
  intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
  neg(isCProvider(C1)) &
delay(
  applyTo(RR,IC,C2) & dec(C2,cmp) &
  neg(isCProvider(C2)) &
  canStart(SystemPerm,C2,C1,S)
, false) &

  dec(IC1,iCmp) &
  comp({[IC1,IC1]},RR,{}) & 

  (intType(I,intActivity) &
   data(I,D) & dec(D,data) &
   (path(D,uric(U)) & dec(U,uri) &
    existsRes(CP,U,S) & dec(CP,cProvider) &
delay(
    canGrant(CP,U,S) &
    applyTo(IntentActionType,I,AT) & dec(AT,pType) &
    (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
     or
     AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
     or
     AT = both & 
     (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
     (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
    )
,false) &
    foplus(DTP,[IC1,CP,U],AT,DTP_)
    or
    path(D,nullu) &
    DTP_ = DTP
   )
   or
   intType(I,intService) &
   DTP_ = DTP
   or
   intType(I,intBroadcast) &
   brperm(I,permc(P)) & dec(P,perm) &
delay(
   appHasPermission(SystemPerm,A,P,S)
, false) &
   DTP_ = DTP
  ) &
% part of post_receiveIntent
  RR_ = {[IC1,C1] / RR} &
  SI = {[IC,I] / SI_} & [IC,I] nin SI_ &
  updateReceiveIntent(S,RR_,DTP_,SI_,S_).

% receiveIntent3 is identical to receiveIntent1 except for delays
% it's used to run property5
:- dec_p_type(
     receiveIntent3(
      set(perm),int,rel(intent,pType),intent,iCmp,idApp,system,system)).
receiveIntent3(SystemPerm,VulnerableSdk,IntentActionType,I,IC,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & running(St_,RR_) & dec([RR,RR_],rel(iCmp,cmp)) &
  sentIntents(St,SI) & sentIntents(St_,SI_) & dec([SI,SI_],set([iCmp,intent])) &
  delTPerms(St,DTP) & delTPerms(St_,DTP_) & 
    dec([DTP,DTP_],rel([iCmp,cProvider,uri],pType)) &

% pre_receiveIntent
  canRun(VulnerableSdk,A,S) &
delay(
  intentForApp(I,A,C1,IC,S) & dec(C1,cmp) &
  neg(isCProvider(C1)) &
  applyTo(RR,IC,C2) & dec(C2,cmp) &
  neg(isCProvider(C2)) &
  canStart(SystemPerm,C2,C1,S)
, false) &

  dec(IC1,iCmp) &
  comp({[IC1,IC1]},RR,{}) & 

  (intType(I,intActivity) &
   data(I,D) & dec(D,data) &
   (path(D,uric(U)) & dec(U,uri) &
    existsRes(CP,U,S) & dec(CP,cProvider) &
delay(
    canGrant(CP,U,S) &
    applyTo(IntentActionType,I,AT) & dec(AT,pType) &
    (AT = read & (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S))
     or
     AT = write & (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
     or
     AT = both & 
     (canRead(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,read,S)) &
     (canWrite(SystemPerm,C2,CP,S) or delPerms(C2,CP,U,write,S))
    )
,false) &
    foplus(DTP,[IC1,CP,U],AT,DTP_)
    or
    path(D,nullu) &
    DTP_ = DTP
   )
   or
   intType(I,intService) &
   DTP_ = DTP
   or
   intType(I,intBroadcast) &
   brperm(I,permc(P)) & dec(P,perm) &
delay(
   appHasPermission(SystemPerm,A,P,S)
, false) &
   DTP_ = DTP
  ) &
% part of post_receiveIntent
  RR_ = {[IC1,C1] / RR} &
  SI = {[IC,I] / SI_} & [IC,I] nin SI_ &
  updateReceiveIntent(S,RR_,DTP_,SI_,S_).


% stop

:- dec_p_type(stop(iCmp,system,system)).
stop(IC,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & running(St_,RR_) & dec([RR,RR_],rel(iCmp,cmp)) &
  delTPerms(St,DTP) & delTPerms(St_,DTP_) & 
    dec([DTP,DTP_],rel([iCmp,cProvider,uri],pType)) &

  RR = {[IC,C1] / RR_} & [IC,C1] nin RR_ & dec(C1,cmp) &
    
  DTP_ = ris([[IC1,CP,U],PT] in DTP,
             IC1 neq IC & 
             dec(IC1,iCmp) & dec(CP,cProvider) & dec(U,uri) & dec(PT,pType)) &

  updateStop(S,RR_,DTP_,S_).


% grantP

:- dec_p_type(ptplus(pType,pType,pType)).
ptplus(PT1,PT2,PT3) :-
  (PT1 = both & PT3 = both
   or
   PT1 = read & ((PT2 = read & PT3 = read) or (PT2 neq read & PT3 = both))
   or
   PT1 = write & ((PT2 = write & PT3 = write) or (PT2 neq write & PT3 = both))
  ).

:- dec_p_type(grantP(set(perm),iCmp,cProvider,idApp,uri,pType,system,system)).
grantP(SystemPerm,IC,CP,A,U,PT,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  delPPerms(St,DPP) & delPPerms(St_,DPP_) & 
    dec([DPP,DPP_],rel([idApp,cProvider,uri],pType)) &

% pre_granP
delay(
  canGrant(CP,U,S) &
  existsRes(CP,U,S) &
  isAppInstalled(A,S) &
  [IC,C] in RR & dec(C,cmp) &
  (PT = read & (canRead(SystemPerm,C,CP,S) or delPerms(C,CP,U,read,S))
   or
   PT = write & (canWrite(SystemPerm,C,CP,S) or delPerms(C,CP,U,write,S))
   or
   PT = both &
   (canRead(SystemPerm,C,CP,S) or delPerms(C,CP,U,read,S)) &
   (canWrite(SystemPerm,C,CP,S) or delPerms(C,CP,U,write,S))
  ) &
% post_grantP
  applyTo(DPP,[A,CP,U],PT1) & dec(PT1,pType) &
  ptplus(PT,PT1,PT_) & dec(PT_,pType)
, false) &
  foplus(DPP,[A,CP,U],PT_,DPP_) &
  updateGrantP(S,DPP_,S_).


% revokedel

:- dec_p_type(ptminus(pType,pType,sum([nullpt,pt(pType)]))).
ptminus(PT1,PT2,PT3) :-
  (PT2 = both & PT3 = nullpt
   or
   PT2 = read & 
   ((PT1 = read & PT3 = nullpt) or (PT1 neq read & PT3 = pt(write)))
   or
   PT2 = write & 
   ((PT1 = write & PT3 = nullpt) or (PT1 neq write & PT3 = pt(read)))
  ).

:- dec_p_type(revokeDel(set(perm),iCmp,cProvider,uri,pType,system,system)).
revokeDel(SystemPerm,IC,CP,U,PT,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  delTPerms(St,DTP) & delTPerms(St_,DTP_) & 
    dec([DTP,DTP_],rel([iCmp,cProvider,uri],pType)) &
  delPPerms(St,DPP) & delPPerms(St_,DPP_) & 
    dec([DPP,DPP_],rel([idApp,cProvider,uri],pType)) &

% pre_revokeDel
delay(
  existsRes(CP,U,S) &
  [IC,C] in RR & dec(C,cmp) &
  (PT = read & (canRead(SystemPerm,C,CP,S) or delPerms(C,CP,U,read,S))
   or
   PT = write & (canWrite(SystemPerm,C,CP,S) or delPerms(C,CP,U,write,S))
   or
   PT = both &
   (canRead(SystemPerm,C,CP,S) or delPerms(C,CP,U,read,S)) &
   (canWrite(SystemPerm,C,CP,S) or delPerms(C,CP,U,write,S))
  ) 
, false) &
% post_revokeDel
  dec([DTP1,DTP2],rel([iCmp,cProvider,uri],pType)) &
  DTP1 = ris([[IC1,CP1,U1],PT1] in DTP,[PT_],
             CP1 = CP & U1 = U &
               dec(IC1,iCmp) &
               dec(CP1,cProvider) & dec(U1,uri) & dec(PT1,pType),
             [[IC1,CP1,U1],PT_],
             ptminus(PT1,PT,pt(PT_)) & dec(PT_,pType)
         ) & 
  DTP2 = ris([[IC2,CP2,U2],PT2] in DTP,
             (CP2 neq CP or U2 neq U) &
               dec(IC2,iCmp) &
               dec(CP2,cProvider) & dec(U2,uri) & dec(PT2,pType)
            ) &
  un(DTP1,DTP2,DTP_) &

  dec([DPP1,DPP2],rel([idApp,cProvider,uri],pType)) &
  DPP1 = ris([[IA3,CP3,U3],PT3] in DPP,[PT3_],
             CP3 = CP & U3 = U &
               dec(IA3,idApp) &
               dec(CP3,cProvider) & dec(U3,uri) & dec(PT3,pType),
             [[IA3,CP3,U3],PT3_],
             ptminus(PT3,PT,pt(PT3_)) & dec(PT3_,pType)
         ) & 
  DPP2 = ris([[IA4,CP4,U4],PT4] in DPP,
             (CP4 neq CP or U4 neq U) &
               dec(IA4,idApp) &
               dec(CP4,cProvider) & dec(U4,uri) & dec(PT4,pType)
            ) &
  un(DPP1,DPP2,DPP_) &

  updateRevokeDel(S,DTP_,DPP_,S_).


% call
:- dec_p_type(permSAC(set(perm),sacall,set(perm))).
permSAC(SystemPerm,SAC,Perms) :-
  subset(Perms,SystemPerm).  

:- dec_p_type(pre_call(set(perm),iCmp,sacall,system)).
pre_call(SystemPerm,IC,SAC,S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  
  applyTo(RR,IC,C) & dec(C,cmp) &
  inApp(C,A,S) & dec(A,idApp) &
  permSAC(SystemPerm,SAC,Perms) & dec(Perms,set(perm)) &
  foreach(P in Perms, appHasPermission(SystemPerm,A,P,S) & dec(P,perm)).
  
:- dec_p_type(call_op(set(perm),iCmp,sacall,system,system)).
call_op(SystemPerm,IC,SAC,S,S_) :-
  pre_call(SystemPerm,IC,SAC,S) &
  S_ = S.


% verifyOldApp

:- dec_p_type(isOldApp(int,idApp,system)).
isOldApp(VulnerableSdk,A,S) :-
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  targetSdk(M,num(N)) & dec(N,int) &
  N < VulnerableSdk.

/*
:- dec_p_type(n_isOldApp(int,idApp,system)).
n_isOldApp(VulnerableSdk,A,S) :-
  isManifestOfApp(A,M,S) & dec(M,manifest) &
  
  (targetSdk(M,nulln) 
   or 
   targetSdk(M,num(N)) & dec(N,int) & VulnerableSdk =< N
  ).

% only used in proofs
:- dec_p_type(pre_verifyOldApp(int,idApp,system)).
pre_verifyOldApp(VulnerableSdk,A,S) :-
  state(S,St) & dec(St,state) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &

  isAppInstalled(A,S) &
  A nin AV &
  isOldApp(VulnerableSdk,A,S).

:- dec_p_type(n_pre_verifyOldApp(int,idApp,system)).
n_pre_verifyOldApp(VulnerableSdk,A,S) :-
  state(S,St) & dec(St,state) &
  alreadyVerified(St,AV) & dec(AV,set(idApp)) &

  neg(
    isAppInstalled(A,S) &
    A nin AV &
    isOldApp(VulnerableSdk,A,S)
  ).
*/

:- dec_p_type(verifyOldApp(int,idApp,system,system)).
verifyOldApp(VulnerableSdk,A,S,S_) :-
  state(S,St) & state(S_,St_) & dec([St,St_],state) &
  alreadyVerified(St,AV) & alreadyVerified(St_,AV_) & dec([AV,AV_],set(idApp)) &
  perms(St,Perms) & perms(St_,Perms_) & 
    dec([Perms,Perms_],rel(idApp,set(perm))) &
  grantedPermGroups(St,MG) & grantedPermGroups(St_,MG_) &
    dec([MG,MG_],rel(idApp,set(idGrp))) &

% pre_verifyOldApp
  isAppInstalled(A,S) &
  A nin AV &
  isOldApp(VulnerableSdk,A,S) &
% post_verifyOldApp
  foplus(Perms,A,{},Perms_) &
  foplus(MG,A,{},MG_) &
  AV_ = {A / AV} &
  updateverifyOldApp(S,Perms_,MG_,AV_,S_).










